import pymongo
import trafilatura
import trafilatura.feeds
import trafilatura.sitemaps
import trafilatura.spider
import sys


def calculate_checksums(self, text):
    """
    @return fingerprints of a paragraphs in text. Paragraphs are separated by a blank line
    """
    checksums = []
    sizes = []
    hval = 0
    hsz = 0
    sz = 0
    for c in text:
        cv = ord(c)
        sz += 1
        if cv > 64:
            hval += (hval << 3) + cv
            zv = hval >> 31
            hval &= 0x7fffffff
            hval += zv
            hsz += 1
        if c == "\n" and hsz > 0:
            if hsz > 100:
                checksums.append(hval)
                sizes.append(sz)
            sz = 0
            hsz = 0
    if hsz > 100:
        checksums.append(hval)
        sizes.append(sz)
    return checksums, sizes


def fetch_pages(link_batch):
    docs  = []
    for link in link_batch:
        link_doc = {"url":link,"status": "html_error"}
        rr = trafilatura.fetch_url(page,decode=True)
        if rr is not None:
            link_doc["status"] = "html_ok"
            link_doc["html"] = rr
        docs.append(link_doc)
    return docs

def extract_pages(link_docs):
    content = []
    extracted_links = set()
    for doc in link_docs:
        if doc["status"] != "html_ok":
            continue
        extracted_doc = trafilatura.bare_extraction(doc["content"],extract_links=True)
        links = extracted_doc["links"]
        extracted_links += links
        del extracted_doc["links"]
        content.append(extracted_doc)
    return content, extracted_links

def index_pages(pagedb,pages_list):
    contentcol = pagedb["content"]
    for page in page_list:
        # get paragraph checksums
        checksums,sizes = get_checksums(page["text"])
        page["paragraph_checksums"] = checksums
        page["paragraph_sizes"] = sizes
    x = contentcol.insert_many(pages_list)
    page_hashes = []

def process_pages(db,fetched_pages):
    content_pages, extracted_links = extract_pages(fetched_pages)
    contentcol = db["content"]
    contentcol.insertMany(content_pages)
    linkcol = db["links"]
    extracted = []
    for link in extracted_links:
        extracted.append({"url":link,"status":"backlink"})
    # shuld fail if link already exists
    linkcol.insertMany(extracted)

    html_pages = []
    for page in fetched_pages:
        linkcol.updateOne({"url":page["url"]},{"$set":{"status":"visited"}})
        if "html" in page:
            html_pages.append({"url":page["url"],"html":page["html"],"update_time":datetime.now()})
            del page["html"]
    htmlcol = db["html"]
    htmlcol.insertMany(html_pages)



def get_visited_links(domain):
    return []

def generic_visit(domain):
    known_links = set(get_visited_links(domain))
    visit_links = []
    visit_links = trafilatura.find_feed_urls(domain)
    if visit_links is None:
        visit_links = trafilatura.sitemap_search(domain)
    if visit_links is None:
        visit_links = trafilatura.focused_crawler(dommain,known_links=known_links)

def simple_visit(domain):
    known_links = []
    #res = trafilatura.spider.focused_crawler(domain,known_links=known_links)
    print(res)
    #visit_links = trafilatura.feeds.find_feed_urls(domain)
    #visit_links = trafilatura.sitemaps.sitemap_search(domain)
    #print(visit_links)
    #for link in visit_links:
    #    content = trafilatura.fetch_url(link,decode=True)
    #    document = trafilatura.bare_extraction(content)
    #    print(content)

simple_visit(sys.argv[1])
